/**********************************************************************
;                                                                     *
;    Filename:	    picFruit24_amplif.c	(amplificatore audio su pcb PicFruit24  *
;    Date:          13/11/17                                           *
;    File Version:  1.00                                              *
;                                                                     *
;    Author:        Dario Greggio                                     *
 * Company:       	Oetztal Automation (Cyberdyne (ADPM Synthesis sas)) *
 * Dependencies:    See INCLUDES section below
 * Processor:       PIC24
 * Compiler:        C30 3.25.00+
;                                                                     *
;**********************************************************************
;                                                                     *
;    Files required:                                                  *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes:                                                           *
;                                                                     *
;**********************************************************************
;                                                                     *
;**********************************************************************/

#include <xc.h>
#include <plib.h>
//#include <adc.h>
//#include <timer.h>
//#include <spi.h>
//#include <i2c.h>
//#include <outcompare.h>
#include "picfruit24.h"
#include <libpic30.h>
#include <ppsnew.h>




// PIC24EP512GP202 Configuration Bit Settings

// FICD
#pragma config ICS = PGD3               // ICD Communication Channel Select bits (Communicate on PGEC1 and PGED1)
#pragma config JTAGEN = OFF             // JTAG Enable bit (JTAG is disabled)

// FPOR
#pragma config ALTI2C1 = OFF            // Alternate I2C1 pins (I2C1 mapped to SDA1/SCL1 pins)
#pragma config ALTI2C2 = OFF            // Alternate I2C2 pins (I2C2 mapped to SDA2/SCL2 pins)
#pragma config WDTWIN = WIN25           // Watchdog Window Select bits (WDT Window is 25% of WDT period)

// FWDT
#pragma config WDTPOST = PS4096         // Watchdog Timer Postscaler bits (1:4,096)
#pragma config WDTPRE = PR32            // Watchdog Timer Prescaler bit (1:32)
#pragma config PLLKEN = ON              // PLL Lock Enable bit (Clock switch to PLL source will wait until the PLL lock signal is valid.)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable bit (Watchdog Timer in Non-Window mode)
#pragma config FWDTEN = ON              // Watchdog Timer Enable bit (Watchdog timer always enabled)

// FOSC
#pragma config POSCMD = NONE            // Primary Oscillator Mode Select bits (Primary Oscillator disabled)
#pragma config OSCIOFNC = ON            // OSC2 Pin Function bit (OSC2 is general purpose digital I/O pin)
#pragma config IOL1WAY = OFF             //per PWM dinamico metto off! Peripheral pin select configuration bit (Allow only one reconfiguration)
#pragma config FCKSM = CSDCMD           // Clock Switching Mode bits (Both Clock switching and Fail-safe Clock Monitor are disabled)

// FOSCSEL
#pragma config FNOSC = FRCPLL           // Oscillator Source Selection (Fast RC Oscillator with divide-by-N with PLL module (FRCPLL))
#pragma config IESO = ON                // Two-speed Oscillator Start-up Enable bit (Start up device with FRC, then switch to user-selected oscillator source)

// FGS
#pragma config GWRP = OFF               // General Segment Write-Protect bit (General Segment may be written)
#pragma config GCP = OFF                // General Segment Code-Protect bit (General Segment Code protect is Disabled)

//_FALTREG(CTXT1_IPL5);    	// boh dovrebbe assegnare i registri per il salvataggio rapido contesto di IRQ.. ma forse XC16 free non li usa...

//_FGS( GWRP_OFF & GCP_OFF ) 
//_FOSCSEL(FNOSC_FRCPLL & IESO_ON)			//FNOSC_FRCPLL 
//_FOSC( POSCMD_HS & OSCIOFNC_ON & IOL1WAY_ON & FCKSM_CSDCMD )
//_FWDT( WDTPOST_PS32768 & WDTPRE_PR32 & PLLKEN_ON & WINDIS_OFF & FWDTEN_OFF )
//_FPOR( WDTWIN_WIN50 & ALTI2C1_OFF & ALTI2C2_OFF )
//_FICD( ICS_PGD3 & JTAGEN_OFF )

//_FAS( AWRP_OFF & APL_OFF & APLK_OFF)
//_FUID0(x) simpa..


//	__IDLOCS 0x4744


typedef void * SHORTPTR;			//

//***** VARIABLE DEFINITIONS

const char CopyrightString[]= {'P','I','C','F','R','U','I','T','2','4','-','F','M',' ','t','r','a','n','s','m','i','t','t','e','r',' ','-',' ','v',
	VERNUMH+'0','.',VERNUML/10+'0',(VERNUML % 10)+'0', ' ','-',' ', '1','4','/','1','1','/','1','7', 0 };

const char CopyrDate[]={ 'S','/','N',' ','0','0','0','1', CR,LF,0 };

const char * const Copyr1="(C) Oetztal Automation 2017 - G.Dar\xd\xa\x0";


//	messg "Numero di serie: SERNUM"





/*
;-------------------------------------------
;       variabili
;-------------------------------------------
*/
volatile BYTE Timer1;					// usato con Timer3 per gestire "eventi/RTC"
WORD CounterL=0xc00;
BYTE CounterH;	



BYTE oldPB2;
BYTE curPB;

WORD LastAD;


BYTE OldValue;			// questo memorizza il valore di luce-dimmer PRIMA di un click (accensione/spegnimento)




/** D E C L A R A T I O N S **************************************************/


// ---------------------------------------------------------------------




/*============================================
;       RESET ENTRY
;============================================ */
int main(void) {
	WORD i;
	BYTE j,temp,temp2;
	SHORTPTR p;

//	if(isWDTTO())				//solo se reset vero (non watchdog!)
//		goto warm_reset;
//	else
//		goto cold_reset;         // go to beginning of program


start:
cold_reset:

//	RCONbits.NOT_BOR=1;
//	StatusReset();

	ClrWdt();



	CLKDIVbits.FRCDIV = 0b000;		// Set 32MHz FRC postscalar pll 

  _PLLDIV=51;						// M = _PLLDIV+2, 2..513
	_PLLPRE=0;						// N1 = _PLLPRE+2, 2..33
	_PLLPOST=0;						// N2 = _PLLPOST, 2 (0), 4 (1), 8 (3)

	OSCTUN=0;			//(da USB)
// 
// (280*7.37)/(8*2) = 129~  (osc interno)
// (280*8)/(8*2) = 140
// (304*8)/(8*2) = 140

/*	
  Fosc= Fin*M/(N1*N2)
	0.8MHz<(Fin/N1)<8MHz
	100MHz<(Fin*M/N1)<340MHz
	M=2,3,4,...513
	N1=2...33
	N2=2,4,8
	
	PLLFBD    = M -2;
	CLKDIVbits.PLLPRE = N1 -2;
	CLKDIVbits.PLLPOST = 0b00; //N2={2,4,R,8} */

//OSCCONbits.CLKLOCK=1;OSCCONbits.NOSC=1;OSCCONbits.OSWEN=1;
//  while (OSCCONbits.COSC != 0x7)LATB ^= 1;; 
//	while(OSCCONbits.LOCK!=1)
//		ClrWdt();


	//Wait for the Primary PLL to lock and then
  // configure the auxiliary PLL to provide 48MHz needed for USB Operation.
#ifndef __DEBUG
  while(OSCCONbits.LOCK != 1) ClrWdt();			// boh?
#endif





	TRISA=0b0000000000000000;						// resetto subito uscite! e il vecchio picfruit18? boh vabbe'
	Delay_mS_free(100);		// sembra sia meglio aspettare un pizzico prima di leggere la EEPROM.. (v. forum 2006)


	LATA= 0b0000000000000000;			// uso cmq alcuni se non tutti i tasti!
	LATB= 0b0000000000000000;			// input & altro; CS

	
	TRISA=0b0000000000011111;						// 2 pulsanti, led, buzzer, 
	TRISB=0b0000000000000000;						// CS, SPI, I2C, UART, 1 pulsante, output (o buzzer)
	
	// 2 output, 3 I/O input, 485! I2C; 0=out x buzzer (RC2)

	ODCA= 0b0000000000000000;
	ODCB= 0b0000000000000000;			// 


  PPSUnLock;
#define OUT_PIN_PPS_RP37			RPOR1bits.RP37R		/* dio merdoso */

  OC1CON1 = 0x0000;
 	PPSOut(_OC1, _RP39);      // 
 	PPSOut(_OC1, _RP37);      // 
  OC1CON2 = 0x0000;
  OC1R    = 1024	 /* basato su SysClock => 32KHz (70MHz / 2048) */;  /* set the duty cycle to 50% */
  OC1RS   = 2048 /* se uso Timer come Src SEMBRA NON FARE NULLA... qua boh! */;  /* set the period */
  OC1CON2 = 0x001f;
  OC1CON1 = 0x1c00 /* 0x0400 => src=Timer3 */;  /* 0x1C08 = Clock source Fcyc, trigger mode 1, Mode 0 (disable OC1) */
  OC1CON1 |= 0x0006;   /* Mode 6, Edge-aligned PWM Mode */ 

  OC2CON1 = 0x0000;
 	PPSOut(_OC2, _RP43);
 	PPSOut(_OC2, _RP42);
  /* Reset PWM */
  OC2CON2 = 0x0000;
  /* set PWM duty cycle to 50%; circa 500Hz, 8.5.17 */
  OC2R    = 1024	 /* basato su SysClock => 32KHz (70MHz / 2048) */;  /* set the duty cycle to 50% */
  OC2RS   = 2048 /* se uso Timer come Src SEMBRA NON FARE NULLA... qua boh! */;  /* set the period */
  /* configure PWM */
  OC2CON2 = 0x001f;   /* 0x001F = Sync with This OC module                               */
  OC2CON1 = 0x1c00 /* 0x0400 => src=Timer3 */;  /* 0x1C08 = Clock source Fcyc, trigger mode 1, Mode 0 (disable OC2) */
  /* enable the PWM */
  OC2CON1 |= 0x0006;   /* Mode 6, Edge-aligned PWM Mode */ 

// mettere altri piedini in parallelo, per pi potenza!

	PPSLock;


//	INTCON=0;					// disabilito tutti interrupt



#define TMR2BASE (25000)						//2012: usato per time-oraesatta; 10mS (impossibile andare a 100!)
#define TMR3BASE (2580-1)						// AD sample in psyche, 40uS


	OpenTimer2(T2_ON & T2_IDLE_CON & T2_GATE_OFF & T2_PS_1_256 & T2_32BIT_MODE_OFF & T2_SOURCE_INT,
		TMR2BASE/2);		//
	ConfigIntTimer2(T2_INT_PRIOR_3 & T2_INT_ON);

	OpenTimer5(T5_ON & T5_IDLE_CON & T5_GATE_OFF & T5_PS_1_1 & T5_SOURCE_INT,
// nel SIMulatore Timer 3 e 4 non vanno... non generano IRQ o hanno tempi a caso... uso 5 ma forse potrei usare altri
		TMR3BASE);		//
	ConfigIntTimer5(T5_INT_PRIOR_5 & T5_INT_ON);


//	CNPUAbits.CNPUA0=1;			// FINIRE!
	CNPUAbits.CNPUA1=1;
	CNPUAbits.CNPUA2=1;
	CNPUAbits.CNPUA3=1;


	ClrWdt();



test:
//i=TMR2;
//Delay_uS(52);
//goto test;



#ifdef DEBUG_PULS
	if(!m_Puls2Bit) {			// dovrei controllare anche Puls1, ma non importa (tanto, per Puls1=0, i valori di test vengono impostati di continuo)
		}
#endif




	CM1CON=0b0000000000000000;			// okkio ai comparatori, 



	{


			AD1CON1 = 0b1001000011100000;			// On, 10bits, no DMA, unsigned int,  manual sampling and auto conversion
			AD1CON2 = 0b0000000000000000;			// VRef VDD/GND, channel 0, no scan, interrupt basic
			AD1CON3 = 0b0001000000100000;			// system clock, 16 Tad, 32*clock
			AD1CON4 = 0b0000000100000000;			// DMA i.e. uso solo ADC1BUF0
			AD1CHS123 = 0b0000000000000000;		// SampleB = VRef-, SampleA = CH0
			AD1CHS0 = 0b0000000000000000;			// CH0 = Sample+
			AD1CSSH = 0b0000000000000000;			// skips all
			AD1CSSL = 0b0000000000000000;			// "

//  	OpenADC10(Adcon1_reg,Adcon2_reg,Adcon3_reg,Adcon4_reg,configchs0,configchs123,configscan_lo,configscan_hi);      // Turn on ADC module
//		EnableADC1;
	}

	ANSELA= 0b0000000000000001;			// in caso mettere 1
	ANSELB= 0b0000000000000000;			// idem

	


    // preparo una prima lettura di tutto, per evitare falsi allarmi!


	oldPB2=curPB;



warm_reset:



	Delay_mS_free(100);




	EnableIntT1;
//	INTCON=0b11100000;				// solo timer, pi...


	do {

		ClrWdt();



		if(!--CounterL) {					// quando il contatore e' zero...
			CounterL=0x6000;		// 100MHz!

			CounterH--;

			if(!(CounterH & FLASH_TIME))
				goto ResCnt;
			
noComRic6:
	;



//		LATA ^= LedOVal;			// ogni circa 18uSec, ago 2012
			}

		ClrWdt();

NoResCnt:

		continue;

	

ResCnt:

//#define m_LedOBit  LATBbits.LATB11		// 
#warning SPOSTARE LED!
		LATB ^= LedOVal;			// 3mS @140MHz, 9.5.17



		ClrWdt();


	
		oldPB2=curPB;		// copio ; i BIT NON usati valgono 1...


	
		} while(1);
	}



// ---------------------------------------------------------------------




// ---------------------------------------------------------------------





// ************* EOF picfruit24_amplif.c ********************************	



